<?php

    namespace Modules\Lpj\Http\Controllers;

    use App\Http\Controllers\Controller;
    use Exception;
    use Illuminate\Http\Request;
    use Maatwebsite\Excel\Facades\Excel;
    use Modules\Lpj\Exports\HubunganPemilikJaminanExport;
    use Modules\Lpj\Http\Requests\HubunganPemilikJaminanRequest;
    use Modules\Lpj\Models\HubunganPemilikJaminan;

    class HubunganPemilikJaminanController extends Controller
    {
        public $user;

        public function index()
        {
            return view('lpj::hubungan_pemilik_jaminan.index');
        }

        public function store(HubunganPemilikJaminanRequest $request)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Save to database
                    HubunganPemilikJaminan::create($validate);
                    return redirect()
                        ->route('basicdata.hubungan-pemilik-jaminan.index')
                        ->with('success', 'Hubungan Pemilik Jaminan created successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.hubungan-pemilik-jaminan.create')
                        ->with('error', 'Failed to create hubungan pemilik jaminan');
                }
            }
        }

        public function create()
        {
            return view('lpj::hubungan_pemilik_jaminan.create');
        }

        public function edit($id)
        {
            $hubunganPemilikJaminan = HubunganPemilikJaminan::find($id);
            return view('lpj::hubungan_pemilik_jaminan.create', compact('hubunganPemilikJaminan'));
        }

        public function update(HubunganPemilikJaminanRequest $request, $id)
        {
            $validate = $request->validated();

            if ($validate) {
                try {
                    // Update in database
                    $hubunganPemilikJaminan = HubunganPemilikJaminan::find($id);
                    $hubunganPemilikJaminan->update($validate);
                    return redirect()
                        ->route('basicdata.hubungan-pemilik-jaminan.index')
                        ->with('success', 'Hubungan Pemilik Jaminan updated successfully');
                } catch (Exception $e) {
                    return redirect()
                        ->route('basicdata.hubungan-pemilik-jaminan.edit', $id)
                        ->with('error', 'Failed to update hubungan pemilik jaminan');
                }
            }
        }

        public function destroy($id)
        {
            try {
                // Delete from database
                $hubunganPemilikJaminan = HubunganPemilikJaminan::find($id);
                $hubunganPemilikJaminan->delete();

                echo json_encode(['success' => true, 'message' => 'Hubungan Pemilik Jaminan deleted successfully']);
            } catch (Exception $e) {
                echo json_encode(['success' => false, 'message' => 'Failed to delete hubungan pemilik jaminan']);
            }
        }

        public function dataForDatatables(Request $request)
        {
            if (is_null($this->user) || !$this->user->can('hubungan_pemilik_jaminan.view')) {
                //abort(403, 'Sorry! You are not allowed to view users.');
            }

            // Retrieve data from the database
            $query = HubunganPemilikJaminan::query();

            // Apply search filter if provided
            if ($request->has('search') && !empty($request->get('search'))) {
                $search = $request->get('search');
                $query->where(function ($q) use ($search) {
                    $q->Where('name', 'LIKE', "%$search%");
                });
            }

            // Apply sorting if provided
            if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
                $order  = $request->get('sortOrder');
                $column = $request->get('sortField');
                $query->orderBy($column, $order);
            }

            // Get the total count of records
            $totalRecords = $query->count();

            // Apply pagination if provided
            if ($request->has('page') && $request->has('size')) {
                $page   = $request->get('page');
                $size   = $request->get('size');
                $offset = ($page - 1) * $size; // Calculate the offset

                $query->skip($offset)->take($size);
            }

            // Get the filtered count of records
            $filteredRecords = $query->count();

            // Get the data for the current page
            $data = $query->get();

            // Calculate the page count
            $pageCount = ceil($totalRecords / $request->get('size'));

            // Calculate the current page number
            $currentPage = 0 + 1;

            // Return the response data as a JSON object
            return response()->json([
                'draw'            => $request->get('draw'),
                'recordsTotal'    => $totalRecords,
                'recordsFiltered' => $filteredRecords,
                'pageCount'       => $pageCount,
                'page'            => $currentPage,
                'totalCount'      => $totalRecords,
                'data'            => $data,
            ]);
        }

        public function export()
        {
            return Excel::download(new HubunganPemilikJaminanExport, 'hubungan_pemilik_jaminan.xlsx');
        }
    }
